# -*- coding: utf-8 -*-
# Copyright (c) 2008-2020, AD SANGFOR
# Filename: NodeInfo.py
# 定义节点配置信息
from APIException import APIException
from ErrorInfo import ErrInfo
from ParentList import ParentList
from urllib2 import base64
import JSONObj as jsono
import urllib
import json
import codecs


class NodeStatus (ErrInfo):
    def __init__(self, httpBody=None):
        ErrInfo.__init__(self, httpBody)
        self.poolName = None
        self.nodeIP = None
        self.nodePort = -1
        self.healStatus = None

    @classmethod
    def generatingAllNodeStatus(cls, httpBody):
        return AllNodeStatus(httpBody)


class AllNodeStatus(ParentList):
    def __init__(self, httpBody=None):
        ParentList.__init__(self, httpBody)
        self.poolName = None
        if httpBody is None or httpBody == "":
            self.originStr = ""
            return
        if self.isFailed() or self.getErrCode() == 0:
            return
        if not isinstance(httpBody, unicode):
            httpBody = unicode(httpBody, "utf8")
        self.originStr = httpBody
        try:
            self.jsonObj = jsono.JSONObj(httpBody)
            if self.jsonObj.hasTag('node'):
                nodeList = self.jsonObj['node']
                for item in nodeList:
                    node = NodeStatus()
                    node.poolName = item['nodePoolName']
                    node.nodeIP = item['nodeIP']
                    node.nodePort = item['nodePort']
                    node.healStatus = item['healStatus']
                    self.elements.append(node)
        except jsono.JSONObjException as e:
            raise APIException(3, e.reason)
