# -*- coding: utf-8 -*-
# Copyright (c) 2008-2016, AD SANGFOR, [Version 6.3.0]
# Filename: ErrorInfo.py

from APIException import APIException
import JSONObj as jsono


# 错误信息类。同时负责解析XML，若解析失败，则抛出异常
class ErrInfo (object):
    def __init__(self, httpBody=None):
        self.beFailed = False
        self.errCode = None
        self.errStr = None
        if httpBody is None or httpBody == "":
            self.originStr = ""
            return
        if not isinstance(httpBody, unicode):
            httpBody = unicode(httpBody, "utf8")
        self.originStr = httpBody
        try:
            self.jsonObj = jsono.JSONObj(httpBody)
            if self.jsonObj.hasTag('err_code'):
                self.errCode = int(self.jsonObj['err_code'])
            if self.jsonObj.hasTag('err_info'):
                if not isinstance(self.jsonObj['err_info'], unicode):
                    self.errStr = self.jsonObj['err_info']
                else:
                    self.errStr = self.jsonObj['err_info'].encode('utf8')
            if self.jsonObj.hasTag('err_code') and not self.errCode == 0:
                self.beFailed = True
        except jsono.JSONObjException, e:
            raise APIException(3, e.reason)

    def isFailed(self):
        return self.beFailed

    def getErrCode(self):
        return self.errCode

    def getErrStr(self):
        return self.errStr

    def __str__(self):
        return str(self.originStr.encode("utf8"))
