# Copyright 2016 F5 Networks Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

import sangforlbaasdriver
import os

from setuptools import find_packages
from setuptools import setup


setup(name='sangfor-openstack-lbaasv2-driver',

      description='Sangfor AD Driver for OpenStack LBaaSv2 service',
      version=sangforlbaasdriver.__version__,
      author='sangfor-openstack-lbaasv2-driver',

      zip_safe=False,

      # Runtime dependencies.
      install_requires=[],
      data_files=[('/etc/neutron/plugins/sangfor', ['etc/neutron/plugins/sangfor/sangfor-openstack-lbaas.ini']),],
      packages=find_packages(exclude=["*.test", "*.test.*", "test*", "test"]),

      classifiers=['Development Status :: 5 - Production/Stable',
                   'License :: OSI Approved :: Apache Software License',
                   'Operating System :: OS Independent',
                   'Programming Language :: Python',
                   'Intended Audience :: Information Technology',
                   'Intended Audience :: System Administrators'],
      entry_points={
                   'neutron.ml2.mechanism_drivers': [
                           'sangforlbaasdriver = sangforlbaasdriver.v2.ad.driver_v2:SangforLbassExtensionDriver'
                   ]
               },
      )
