#!/usr/bin/python
#!-*- coding:utf-8 -*-
import os
import sys
import shutil

libs = []
try:
    import sangfor_openstack_agent
    libs.append(sangfor_openstack_agent.__file__)
except:
    pass

try:
    import sangforlbaasdriver
    libs.append(sangforlbaasdriver.__file__)
except:
    pass

try:
    from neutron_lbaas.drivers import sangfor
    libs.append(sangfor.__file__)
except:
    pass

dirs = [
    "/etc/neutron/plugins/sangfor",
    "/etc/neutron/services/sangfor",
]

files = [
    "/etc/init.d/sangfor-openstack-agent",
    "/usr/lib/systemd/system/sangfor-oslbaasv2-agent.service"
]

def uninstall():
    #prepare dir
    for i in libs:
        filepath = i
        while True:
            filename = filepath
            filepath = os.path.dirname(filepath)
            if filename.find("sangfor") == -1:
                break
            if filepath.find("sangfor") != -1:
                continue
            if os.path.isfile(filename):
                files.append(filename)
            else:
                dirs.append(filename)

    #prepre file
    for p in os.getenv("PATH", "").split(":"):
        f = "%s/%s" % (p, "sangfor-oslbaasv2-agent")
        if os.path.isfile(f):
            files.append(f)

    #remove
    for d in dirs:
        print "remove dir %s" % d
        try:
            shutil.rmtree(d)
        except Exception as e:
            print e
    for f in files:
        print "remove file %s" % f
        try:
            os.unlink(f)
        except Exception as e:
            print e

if __name__ == "__main__":
    uninstall()
